#!/bin/bash

set -e

cd $HOME
mkdir -p git

clone_repo() {
	repo_url=$1
	dest_dir=$2

	if [[ -e $dest_dir ]]; then
		return 0
	fi

	git clone "$repo_url" "$dest_dir"
}

clone_repo git://git.server-speed.net/users/flo/bin bin
clone_repo git://git.server-speed.net/users/flo/dotfiles git/dotfiles

for i in .zshrc .vimrc .screenrc .screenrc-2 .zprofile .htoprc .dircolors .vim .gitconfig .gitignore .bashrc .zshenv; do
	ln -sf git/dotfiles/$i $i
done

mkdir -p .zsh
touch .zshrc.local
